.section .text.init
.global _start
_start:
    li t0, 3
    li t1, 4
    auipc t4, 0x100
    
    add t2, t0, t1
    li t3, 7
    bne t2, t3, fail

    sub t2, t0, t1
    li t3, -1
    bne t2, t3, fail

    sll t2, t0, t1
    li t3, 48
    bne t2, t3, fail

    sll t2, t0, t1
    li t3, 48
    bne t2, t3, fail

    xor t2, t0, t1
    li t3, 7
    bne t2, t3, fail

    or t2, t0, t1
    li t3, 7
    bne t2, t3, fail

    and t2, t0, t1
    li t3, 0
    bne t2, t3, fail


# --------------------------------------------------------------------------------


    li t0, 55
    li t1, 3

    srl t2, t0, t1
    li t3, 6
    bne t2, t3, fail



# --------------------------------------------------------------------------------



    li t0, 55

    srli t2, t0, 4
    li t3, 3
    bne t2, t3, fail




# --------------------------------------------------------------------------------




    li t0, 3

    addi t2, t0, 5
    li t3, 8
    bne t2, t3, fail

    slli t2, t0, 5
    li t3, 96
    bne t2, t3, fail

    xori t2, t0, 5
    li t3, 6
    bne t2, t3, fail

    ori t2, t0, 5
    li t3, 7
    bne t2, t3, fail

    andi t2, t0, 5
    li t3, 1
    bne t2, t3, fail

# --------------------------------------------------------------------------------


    la t0, test
    li t1, 0xfafafafa
    sw t1, 0(t0)
    lw t2, 0(t0)
    bne t1, t2, fail


# --------------------------------------------------------------------------------

    li t0, -2
    li t1, 4

    slt t2, t0, t1
    li t3, 1
    bne t2, t3, fail

    sltu t2, t0, t1
    li t3, 0
    bne t2, t3, fail

    slti t2, t0, 5
    li t3, 1
    bne t2, t3, fail

    sltiu t2, t0, 5
    li t3, 0
    bne t2, t3, fail

# --------------------------------------------------------------------------------

    li t0, -2
    li t1, 4

    beq t0, t1, fail
    blt t0, t1, n1
    jal fail
n1:
    bge t0, t1, fail
    bltu t0, t1, fail
    bgeu t0, t1, n2
    jal fail
n2:

# --------------------------------------------------------------------------------

    la t0, test2

    lb t1, 0(t0)
    li t2, 0x44
    bne t1, t2, fail

    lb t1, 1(t0)
    li t2, 0x33
    bne t1, t2, fail

    lh t1, 2(t0)
    li t2, 0x1122
    bne t1, t2, fail


# --------------------------------------------------------------------------------

    la t0, test3

    lb t1, 0(t0)
    li t2, -1
    bne t1, t2, fail

    lbu t1, 0(t0)
    li t2, 0xff
    bne t1, t2, fail

    lh t1, 0(t0)
    li t2, -1
    bne t1, t2, fail

    lhu t1, 0(t0)
    li t2, 0xffff
    bne t1, t2, fail

# --------------------------------------------------------------------------------

    la t0, test3
    li t1, 0

    sb t1, 0(t0)
    li t2, 0xffffff00
    lw t3, 0(t0)
    bne t2, t3, fail

    sb t1, 1(t0)
    li t2, 0xffff0000
    lw t3, 0(t0)
    bne t2, t3, fail

    sh t1, 2(t0)
    li t2, 0
    lw t3, 0(t0)
    bne t2, t3, fail

    la t0, here
    jalr 4(t0)
here:
    jal fail

# --------------------------------------------------------------------------------

    li t0, -2
    li t1, 8

    sra t2, t0, t1
    li t3, 0xffffffff
    bne t2, t3, fail

    srai t2, t0, 7
    li t3, 0xffffffff
    bne t2, t3, fail


# --------------------------------------------------------------------------------

    li t0, 22222
    li t1, 8

    sra t2, t0, t1
    li t3, 0x56
    bne t2, t3, fail

    sra t2, t0, 7
    li t3, 0xad
    bne t2, t3, fail

    jal done


fail:
    li t0, 0xffff
    li t1, 0xff
    sw t1, 0(t0)
    jal loop

done:
    li t0, 0xffff
    li t1, 0x00
    sw t1, 0(t0)
    jal loop



loop:
    beq t0, t0, loop

.section .data
.align 2
test: .word 0
test2: .word 0x11223344
test3: .word -1