.section .text.init
.global _start
_start:
    li t0, 0x80000008
    li t1, 234
    sw t1, 0(t0) # set scaler

    la t2, hello
loop:
    lb t3, 0(t2) # load char from ram
    beq zero, t3, done

    sw t3, 4(t0) # set uart tx 
    addi t2, t2, 1

wait:
    lw t3, 4(t0) # load uart tx state
    bne zero, t3, wait

    j loop

done:
    beq x0, x0, done

.section .data

.align 2
hello:
    .ascii "Hello world from risc-v!\n\0"
# .align 2